#ifndef DUCHAMP_ASTRO_IMAGE_H_
#define DUCHAMP_ASTRO_IMAGE_H_

#include <iostream>
#include <duchamp/duchamp.hh>
#include <duchamp/fitsHeader.hh>
#include <duchamp/DataArrays/SmarkMask.hh>

namespace duchamp
{

    enum PIXELSTATUS {AVAILABLE, DETECTED, BLANK, MW, NEW};

    template <class T> 
    class AstroImage : public DataArrayBase<T>
    {
    public:
	AstroImage();
	AstroImage(const AstroImage& other);
	AstroImage& operator= (const AstroImage& other);
	virtual ~AstroImage(){};

	FitsHeader *head(){return itsHeader;};
	void setHeader(FitsHeader *head){itsHeader = head;};
	DataArrayBase<PIXELSTATUS> *mask(){return itsMask;};

	void readFromFITS(std::string fitsname);

    protected:
	FitsHeader *itsHeader; // use pointer so we can share across many AstroImages
	SmartMask  *itsMask;   // use pointer so we can share across many AstroImages
    };

}

#include <duchamp/DataArrays/AstroImage.tcc>

#endif
